;/*************************************************************************
;** interpcom-1.2 (command interpreter)                                   **
;** graph_lion.cmd : a program file for the application graph of the      **
;**                  command interpreter                                  **
;**                                                                       **
;** Copyright (C) 1999  Jean-Marc Drezet                                  **
;**                                                                       **
;**  This library is free software; you can redistribute it and/or        **
;**  modify it under the terms of the GNU Library General Public          **
;**  License as published by the Free Software Foundation; either         **
;**  version 2 of the License, or (at your option) any later version.     **
;**									  **
;**  This library is distributed in the hope that it will be useful,      **
;**  but WITHOUT ANY WARRANTY; without even the implied warranty of       **
;**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    **
;**  Library General Public License for more details. 			  **
;**									  **
;**  You should have received a copy of the GNU Library General Public    **
;**  License along with this library; if not, write to the Free		  **
;**  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   **
;**                                                                       **
;** Please mail any bug reports/fixes/enhancements to me at:              **
;**      drezet@math.jussieu.fr                                           **
;** or                                                                    **
;**      Jean-Marc Drezet                                                 **
;**      Institut de Mathematiques                                        **
;**      Aile 45-55                                                       **
;**      2, place Jussieu                                                 **
;**      75251 Paris Cedex 05                                             **
;**      France								  **
;**                                                                       **
; *************************************************************************/
;
;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  simple program producing a X11 graphic
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
:lion_X11
2
0
-1
;
;
defcolor red
color red 1 0 0
defgraph_X11 lion1 640*#1 480*#1 
setcolor lion1 red
dt=pi/500
t=0
x0=320.
y0=90.
xx0=x0
yy0=20.
graphplot lion1 x0*#1 y0*#1
;
do i 1 1000
t=t+dt
x=320.+150.*sin(2.*t)
y=240.-150.*cos(3.*t)
xx=x+50.*sin(20.*t)
yy=y-70.*cos(20.*t)
graphline lion1 x0*#1 y0*#1
graphline lion1 x*#1 y*#1
graphline lion1 xx*#1 yy*#1
graphline lion1 xx0*#1 yy0*#1
graphline lion1 x0*#1 y0*#1
graphline lion1 x*#1 y*#1
x0=x
y0=y
xx0=xx
yy0=yy
enddo
destroy red
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  simple program producing a PS graphic
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
:lion_PS
3
0
-1
;
;
defgraph_PS lionPS #2 po
dt=pi/500
t=0
x0=320.
y0=90.
xx0=x0
yy0=20.
graphplot lionPS x0*#1 y0*#1
;
do i 1 1000
t=t+dt
x=320.+150.*sin(2.*t)
y=240.-150.*cos(3.*t)
xx=x+50.*sin(20.*t)
yy=y-70.*cos(20.*t)
graphline lionPS x0*#1 y0*#1
graphline lionPS x*#1 y*#1
graphline lionPS xx*#1 yy*#1
graphline lionPS xx0*#1 yy0*#1
graphline lionPS x0*#1 y0*#1
graphline lionPS x*#1 y*#1
x0=x
y0=y
xx0=xx
yy0=yy
enddo
;
destroy lionPS
echo Postscript file #2 created ! \n
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  the same graphic as in program lion_X11 but with a frame
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
:lion_X11_c
3
0
-1
;
;
defcolor red
color red 1 0 0
defgraph_X11 lion2 640*#1 480*#1 
defframe f
frame f 320*#1*(1-#2) 320*#1*(1+#2) 240*#1*(1-#2) 240*#1*(1+#2) 640*#1 480*#1 
setframe lion2 f
setcolor lion2 red
dt=pi/500
t=0
x0=320.
y0=90.
xx0=x0
yy0=20.
graphplot_c lion2 f x0*#1 y0*#1
;
do i 1 1000
t=t+dt
x=320.+150.*sin(2.*t)
y=240.-150.*cos(3.*t)
xx=x+50.*sin(20.*t)
yy=y-70.*cos(20.*t)
graphline_c lion2 f x0*#1 y0*#1
graphline_c lion2 f x*#1 y*#1
graphline_c lion2 f xx*#1 yy*#1
graphline_c lion2 f xx0*#1 yy0*#1
graphline_c lion2 f x0*#1 y0*#1
graphline_c lion2 f x*#1 y*#1
x0=x
y0=y
xx0=xx
yy0=yy
enddo
;
destroy red
destroy f
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  4 graphics in 4 frames on the same X11 window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
:lion_X11_c_b
1
0
-1
;
;
defcolor blue
color blue 0 0 1
defgraph_X11 XXX 800 600
defframe f1
defframe f2
defframe f3
defframe f4
frame f1 0 800 0 600 800 600
frame f2 120 680 90 510 800 600
frame f3 240 560 180 420 800 600
frame f4 360 440 240 360 800 600
setclip .05 .45 .05 .45 
setframe XXX f1 
setclip .55 .95 .05 .45 
setframe XXX f2 
setclip .05 .45 .55 .95 
setframe XXX f3 
setclip .55 .95 .55 .95 
setframe XXX f4 
;
;
setcolor XXX blue
dt=pi/500
setclip .05 .45 .05 .45 
lion_plot f1
setclip .55 .95 .05 .45 
lion_plot f2
setclip .05 .45 .55 .95 
lion_plot f3
setclip .55 .95 .55 .95 
lion_plot f4
;
destroy f1
destroy f2
destroy f3
destroy f4
destroy blue
;
; restore the original frame size
setclip 0.15 .9 .1 .9
;
;
;
;
:lion_plot
2
0
-1
t=0
x0=400.
y0=112.
xx0=x0
yy0=25.
graphplot_c XXX #1 x0 y0
;
do i 1 1000
t=t+dt
x=400.+187.*sin(2.*t)
y=300.-187.*cos(3.*t)
xx=x+62.*sin(20.*t)
yy=y-87.*cos(20.*t)
graphline_c XXX #1 x0 y0
graphline_c XXX #1 x y
graphline_c XXX #1 xx yy
graphline_c XXX #1 xx0 yy0
graphline_c XXX #1 x0 y0
graphline_c XXX #1 x y
x0=x
y0=y
xx0=xx
yy0=yy
enddo
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  4 graphics in 4 frames in the same PS file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
:lion_c_b_PS
2
0
-1
;
;
defcolor blue
color blue 0 0 1
defgraph_PS YYY W.ps portrait
defframe f1
defframe f2
defframe f3
defframe f4
frame f1 0 800 0 600 800 600
frame f2 120 680 90 510 800 600
frame f3 240 560 180 420 800 600
frame f4 360 440 240 360 800 600
setclip .05*#1 .45*#1 .05*#1 .45*#1
setframe YYY f1 
setclip .55*#1 .95*#1 .05*#1 .45*#1 
setframe YYY f2 
setclip .05*#1 .45*#1 .55*#1 .95*#1 
setframe YYY f3 
setclip .55*#1 .95*#1 .55*#1 .95*#1
setframe YYY f4 
;
;
setcolor YYY blue
dt=pi/500
setclip .05*#1 .45*#1 .05*#1 .45*#1 
lion_plot_PS f1
setclip .55*#1 .95*#1 .05*#1 .45*#1 
lion_plot_PS f2
setclip .05*#1 .45*#1 .55*#1 .95*#1 
lion_plot_PS f3
setclip .55*#1 .95*#1 .55*#1 .95*#1
lion_plot_PS f4
;
destroy f1
destroy f2
destroy f3
destroy f4
destroy blue
destroy YYY
setclip 0.15 0.9 0.1 0.9
echo Postscript file W.ps created ! \n
;
;
;
;
:lion_plot_PS
2
0
-1
t=0
x0=400.
y0=112.
xx0=x0
yy0=25.
graphplot_c YYY #1 x0 y0
;
do i 1 1000
t=t+dt
x=400.+187.*sin(2.*t)
y=300.-187.*cos(3.*t)
xx=x+62.*sin(20.*t)
yy=y-87.*cos(20.*t)
graphline_c YYY #1 x0 y0
graphline_c YYY #1 x y
graphline_c YYY #1 xx yy
graphline_c YYY #1 xx0 yy0
graphline_c YYY #1 x0 y0
graphline_c YYY #1 x y
x0=x
y0=y
xx0=xx
yy0=yy
enddo
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  PS version of lion_X11_c
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
:lion_c_PS
2
0
-1
;
;
defcolor red
color red 1 0 0
defgraph_PS lion3 lion3.ps landscape
defframe f
frame f 320*(1-#1) 320*(1+#1) 240*(1-#1) 240*(1+#1) 640 480 
setframe lion3 f 
setcolor lion3 red
dt=pi/500
t=0
x0=320.
y0=90.
xx0=x0
yy0=20.
graphplot_c lion3 f x0 y0
;
do i 1 1000
t=t+dt
x=320.+150.*sin(2.*t)
y=240.-150.*cos(3.*t)
xx=x+50.*sin(20.*t)
yy=y-70.*cos(20.*t)
graphline_c lion3 f x0 y0
graphline_c lion3 f x y
graphline_c lion3 f xx yy
graphline_c lion3 f xx0 yy0
graphline_c lion3 f x0 y0
graphline_c lion3 f x y
x0=x
y0=y
xx0=xx
yy0=yy
enddo
;
destroy red
destroy lion3
destroy f
echo Postscript file lion3.ps created ! \n
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  execution of all the preceeding programs
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
:all
1
1
-1
lion_X11 1
lion_PS .7 lion1.ps
lion_X11_c 1 .8
lion_X11_c_b
lion_c_b_PS .9
lion_c_PS .8
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  to destroy the X11 windows produced by the preceeding program
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
:clean
1
1
-1
destroy lion1
destroy lion2
destroy XXX
;
;
;
;
