/*************************************************************************
** interpcom-1.2 (command interpreter)                                   **
** main.c : graphic application of the mini-command interpreter          **
**                                                                       **
** Copyright (C) 1999  Jean-Marc Drezet                                  **
**                                                                       **
**  This library is free software; you can redistribute it and/or        **
**  modify it under the terms of the GNU Library General Public          **
**  License as published by the Free Software Foundation; either         **
**  version 2 of the License, or (at your option) any later version.     **
**									 **
**  This library is distributed in the hope that it will be useful,      **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    **
**  Library General Public License for more details. 			 **
**									 **
**  You should have received a copy of the GNU Library General Public    **
**  License along with this library; if not, write to the Free		 **
**  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   **
**                                                                       **
** Please mail any bug reports/fixes/enhancements to me at:              **
**      drezet@math.jussieu.fr                                           **
** or                                                                    **
**      Jean-Marc Drezet                                                 **
**      Institut de Mathematiques                                        **
**      Aile 45-55                                                       **
**      2, place Jussieu                                                 **
**      75251 Paris Cedex 05                                             **
**      France								 **
**                                                                       **
 *************************************************************************/

#include "interp.h"
#include "graph.h"

FUNCTION *Funcs;
int _GRAPH_MESS = 0;
int _GRAPH_X11  = 1;
int _GRAPH_PS   = 2;
int _GRAPH_COL  = 3;
int _GRAPH_FRAM = 4;
pfi *proc[]=
{
proc_graph,
};

int
main(int argc, char *argv[])
{
    Funcs = Funcs_interp;
    _NBFONC = _NBFONC0;
    prog_c(argc, argv, "graph.ini", NULL, 0);
    return 0;
}

void
init_prog()
{
    init_prog_graph();
}

void
exit_prog()
{
    exit(0);
}
 
void
dest_prop(int typ, int i0)
{
    float	   *xx;
    
    if (typ == _GRAPH_X11 - 1 || typ == _GRAPH_PS - 1) {
  	xx = (float *) Obj[typ][i0].adresse;
	g2_close((int) xx[2]);
    }
}
